//
//	main.cpp - source file
//
//	David Henry - tfc_duke@club-internet.fr
//


#include	<GL/glfw.h>
#include	<iostream>

#include	"texture.h"

#pragma comment( lib, "glfw.lib" )
#pragma comment( lib, "opengl32.lib" )
#pragma comment( lib, "glu32.lib" )



/////////////////////////////////////////////////
// textures des six faces du cube
GLuint	texture[6];

// camra
struct vector
{
	float x, y, z;

} rot, eye;
/////////////////////////////////////////////////



// ----------------------------------------------
// Init() - initialisation d'opengl.
// ----------------------------------------------

void Initialize( int argc, char *argv[] )
{
	glClearColor( 0.2f, 0.2f, 0.2f, 0.0f );
	glShadeModel( GL_SMOOTH );

	glEnable( GL_DEPTH_TEST );
	glEnable( GL_TEXTURE_2D );
	
	/////////////////////////////////////////////

	// initialisation camra
	rot.x = 0.0;		eye.x = 0.0;
	rot.y = 0.0;		eye.y = 0.0;
	rot.z = 0.0;		eye.z = 5.0;

	// initialisation du texture manager
	CTextureManager *pTexMgr = CTextureManager::GetInstance();
	pTexMgr->Initialize();

	texture[0] = pTexMgr->LoadTexture( "data/nvidia.bmp" );
	texture[1] = pTexMgr->LoadTexture( "data/nvidia2.bmp" );
	texture[2] = pTexMgr->LoadTexture( "data/opengl.bmp" );
	texture[3] = pTexMgr->LoadTexture( "data/marble.bmp" );
	texture[4] = pTexMgr->LoadTexture( "data/ati2.bmp" );
	texture[5] = pTexMgr->LoadTexture( "data/ati.bmp" );
}



// ----------------------------------------------
// Shutdown() - fin du programme.
// ----------------------------------------------

void Shutdown( void )
{
	// destruction du texture manager
	CTextureManager::Kill();
}



// ----------------------------------------------
// Reshape() - rinitialisation de la fentre
// lors d'un redimensionnement...
// ----------------------------------------------

void GLFWCALL Reshape( int width, int height )
{
	// on vite les divisions par zro...
	if( height == 0 )
		height = 1;

	glViewport( 0, 0, width, height );

	// on rinitialise la matrice de projection
	glMatrixMode( GL_PROJECTION );
	glLoadIdentity();
	gluPerspective( 45.0, (float)width/(float)height, 0.1, 1000.0 );

	// on rinitialise la matrice de modlisation/visualisation
	glMatrixMode( GL_MODELVIEW );
	glLoadIdentity();
}



// ----------------------------------------------
// Display() - redessine la scne opengl.
// ----------------------------------------------

void Display( void )
{
	// on nettoie l'cran pour redesiner la scne
	glClear( GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT );
	glLoadIdentity();


	// rotation camra
	glTranslatef( -eye.x, -eye.y, -eye.z );
	glRotatef( rot.x, 1.0f, 0.0f, 0.0f );
	glRotatef( rot.y, 0.0f, 1.0f, 0.0f );
	glRotatef( rot.z, 0.0f, 0.0f, 1.0f );


	// dessin d'un cube textur

	// face avant
	glBindTexture( GL_TEXTURE_2D, texture[0] );
	glBegin( GL_QUADS );
		glTexCoord2f( 0.0f, 0.0f ); glVertex3f( -1.0f, -1.0f,  1.0f );
		glTexCoord2f( 1.0f, 0.0f ); glVertex3f( 1.0f, -1.0f,  1.0f );
		glTexCoord2f( 1.0f, 1.0f ); glVertex3f( 1.0f,  1.0f,  1.0f );
		glTexCoord2f( 0.0f, 1.0f ); glVertex3f( -1.0f,  1.0f,  1.0f );
	glEnd();

	// face arrire
	glBindTexture( GL_TEXTURE_2D, texture[1] );
	glBegin( GL_QUADS );
		glTexCoord2f( 1.0f, 0.0f ); glVertex3f( -1.0f, -1.0f, -1.0f );
		glTexCoord2f( 1.0f, 1.0f ); glVertex3f( -1.0f,  1.0f, -1.0f );
		glTexCoord2f( 0.0f, 1.0f ); glVertex3f( 1.0f,  1.0f, -1.0f );
		glTexCoord2f( 0.0f, 0.0f ); glVertex3f( 1.0f, -1.0f, -1.0f );
	glEnd();

	// face du dessus
	glBindTexture( GL_TEXTURE_2D, texture[2] );
	glBegin( GL_QUADS );
		glTexCoord2f( 0.0f, 1.0f ); glVertex3f( -1.0f,  1.0f, -1.0f );
		glTexCoord2f( 0.0f, 0.0f ); glVertex3f( -1.0f,  1.0f,  1.0f );
		glTexCoord2f( 1.0f, 0.0f ); glVertex3f( 1.0f,  1.0f,  1.0f );
		glTexCoord2f( 1.0f, 1.0f ); glVertex3f( 1.0f,  1.0f, -1.0f );
	glEnd();

	// face du dessous
	glBindTexture( GL_TEXTURE_2D, texture[3] );
	glBegin( GL_QUADS );
		glTexCoord2f( 1.0f, 1.0f ); glVertex3f( -1.0f, -1.0f, -1.0f );
		glTexCoord2f( 0.0f, 1.0f ); glVertex3f( 1.0f, -1.0f, -1.0f );
		glTexCoord2f( 0.0f, 0.0f ); glVertex3f( 1.0f, -1.0f,  1.0f );
		glTexCoord2f( 1.0f, 0.0f ); glVertex3f( -1.0f, -1.0f,  1.0f );
	glEnd();

	// face droite
	glBindTexture( GL_TEXTURE_2D, texture[4] );
	glBegin( GL_QUADS );
		glTexCoord2f( 1.0f, 0.0f ); glVertex3f( 1.0f, -1.0f, -1.0f );
		glTexCoord2f( 1.0f, 1.0f ); glVertex3f( 1.0f,  1.0f, -1.0f );
		glTexCoord2f( 0.0f, 1.0f ); glVertex3f( 1.0f,  1.0f,  1.0f );
		glTexCoord2f( 0.0f, 0.0f ); glVertex3f( 1.0f, -1.0f,  1.0f );
	glEnd();

	// face gauche
	glBindTexture( GL_TEXTURE_2D, texture[5] );
	glBegin( GL_QUADS );
		glTexCoord2f( 0.0f, 0.0f ); glVertex3f( -1.0f, -1.0f, -1.0f );
		glTexCoord2f( 1.0f, 0.0f ); glVertex3f( -1.0f, -1.0f,  1.0f );
		glTexCoord2f( 1.0f, 1.0f ); glVertex3f( -1.0f,  1.0f,  1.0f );
		glTexCoord2f( 0.0f, 1.0f ); glVertex3f( -1.0f,  1.0f, -1.0f );
	glEnd();
}



// ----------------------------------------------
// Keyboard() - capture clavier.
// ----------------------------------------------

void GLFWCALL Keyboard( int key, int state )
{
	if( state == GLFW_PRESS )
	{
		switch( key )
		{

			case 'S':
				glPolygonMode( GL_FRONT_AND_BACK, GL_FILL );
				break;

			case 'W':
				glPolygonMode( GL_FRONT_AND_BACK, GL_LINE );
				break;

			case GLFW_KEY_ESC:
				glfwCloseWindow();
				break;
		}
	}
}



// ----------------------------------------------
// MouseMove() - contrle souris.
// ----------------------------------------------

void GLFWCALL MouseMove( int x, int y )
{
	static int x_pos = 0;
	static int y_pos = 0;

	if( glfwGetMouseButton( GLFW_MOUSE_BUTTON_RIGHT ) )
	{
		// zoom
		eye.z += (x - x_pos) * 0.01;
	}
	else if( glfwGetMouseButton( GLFW_MOUSE_BUTTON_LEFT ) )
	{
		if( glfwGetKey( GLFW_KEY_LSHIFT ) || glfwGetKey( GLFW_KEY_RSHIFT ) )
		{
			// translation
			eye.x -= (x - x_pos) * 0.01;
			eye.y += (y - y_pos) * 0.01;
		}
		else
		{
			// rotation
			rot.x += (y - y_pos);
			rot.y += (x - x_pos);
		}
	}

	x_pos = x;
	y_pos = y;
}



// ----------------------------------------------
// main() - fonction principale.
// ----------------------------------------------

int main( int argc, char *argv[] )
{
	glfwInit();

	if( glfwOpenWindow( 640, 480, 0, 0, 0, 0, 16, 0, GLFW_WINDOW ) )
    {
		glfwSetWindowSizeCallback( Reshape );
		glfwSetKeyCallback( Keyboard );
		glfwSetMousePosCallback( MouseMove );

		glfwSetWindowTitle( "OpenGL Texture Manager Demo" );

		glfwEnable( GLFW_KEY_REPEAT );

		Initialize( argc, argv );

		while( glfwGetWindowParam( GLFW_OPENED ) )
		{
			Display();
			glfwSwapBuffers();
		}

		Shutdown();
	}

	glfwTerminate();
	return 0;
}
